<template>
  <div
    data-component-group="lang"
    data-component="input"
  >
    <base-dropdown
      :title="selectedLanguage ? selectedLanguage.name : 'Language'"
      :items="languages"
      item-key="code"
      item-value="name"
      :on-change-item="onChangeLanguage"
    />
    <v-textarea
      v-if="!isEditor"
      :value="value"
      label="Enter translation..."
      :error-messages="errorMessages"
      @input="onChangeValue"
      @blur="onBlur"
    />

    <base-enhanced-editor
      v-else
      :value="value"
      :config="editorConfig"
      :disabled="isDisabled"
      :error-messages="errorMessages"
      @input="onChangeValue"
      @blur="onBlur"
    />
  </div>
</template>

<script>
  import { isObj, isStr } from '../../utils';

  // TODO: Translate component

  export default {
    props: {
      translations: {
        type: Array,
        required: true
      },
      isEditor: {
        type: Boolean,
        default: false
      },
      errorMessages: {
        type: Array,
        default() {
          return [];
        }
      },
      isDisabled: {
        type: Boolean,
        default: false
      },
      onBlur: {
        type: Function,
        default: () => {}
      }
    },
    data() {
      return {
        languages: [],
        selectedLanguage: {},
        editorConfig: {
          placeholder: 'Type comment here...',
          btns: [
            ['bold', 'italic', 'underline', 'del'],
            ['unorderedList', 'orderedList'],
            ['link', 'removeformat']
          ]
        },
        hasLanguages: false,
        isSynced: false
      };
    },
    computed: {
      value: {
        get() {
          const language = this.languages.find(language => language.isSelected);
          return isObj(language) ? language.value : '';
        },
        set(nextValue) {
          this.languages.map(language => ({
            ...language,
            value: language.isSelected
              ? nextValue
              : language.value || ''
          }));
        }
      },
    },
    watch: {
      translations(nextTranslations) {
        this.languages = this.syncValues(this.languages, nextTranslations);
      }
    },
    created() {
      this.$watch(() => {
        let nextLanguages = this.$store.getters['config/languages'];

        if (this.languages.length !== nextLanguages.length) {
          nextLanguages = this.sortLanguages(nextLanguages);
          this.languages = this.syncValues(nextLanguages, this.translations);
          this.selectedLanguage = nextLanguages[0];
          const languages = this.formatLanguages(this.languages);

          this.$emit('ready', languages);
        }
      });
    },
    methods: {
      syncValues(languages, translations) {
        const hasSelectedLanguage = isStr(this.selectedLanguage.code);

        return languages.map((language, index) => {
          const translation = translations.find(translation => translation.code === language.code);

          return {
            ...language,
            isSelected: hasSelectedLanguage ? language.isSelected : index === 0,
            value: isObj(translation)
              ? translation.value
              : ''
          };
        });
      },
      onChangeLanguage(selectedLanguage) {
        this.selectedLanguage = selectedLanguage;
        this.languages = this.languages.map(language => ({
          ...language,
          isSelected: language.code === selectedLanguage.code
        }));
      },
      onChangeValue(nextValue) {
        this.languages = this.languages.map(language => ({
          ...language,
          value: language.isSelected
            ? nextValue
            : language.value
        }));

        const languages = this.formatLanguages(this.languages);
        this.$emit('input', languages);
      },
      formatLanguages(languages) {
        return languages.map(({ code, name, value }) => ({ code, name, value }));
      },
      sortLanguages(languages) {
        return languages.sort((a, b) => {
          if (a.code === 'en') {
            return -1;
          } else if (b.code === 'en') {
            return 1;
          }

          return a.code > b.code;
        });
      }
    }
  };
</script>

<style lang="stylus">
  [data-component-group="lang"] {
    &[data-component="input"] {

      [data-component="dropdown"] {
        text-align: right;
        margin: 0 0 10px 0;

        .trigger.toggle-menu {
          margin-right: 0;
        }
      }

      textarea {
        height: 200px;
        max-height: 320px;
        border-radius: 4px;
      }
    }
  }
</style>
